--- old/usr/src/uts/common/io/scsi/adapters/mpt_sas/mptsas_impl.c	2014-12-19 13:49:24.674335462 -0500
+++ new/usr/src/uts/common/io/scsi/adapters/mpt_sas/mptsas_impl.c	2014-12-19 13:49:24.683097715 -0500
@@ -1203,10 +1203,15 @@
 		mptsas_log(mpt, CE_WARN, "mptsas_ioc_task_management failed "
 		    "try to reset ioc to recovery!");
 		mpt->m_softstate &= ~MPTSAS_SS_MSG_UNIT_RESET;
-		if (mptsas_restart_ioc(mpt)) {
+		/* Let's try this instead of the old codepath commented below... */
+		ddi_taskq_dispatch(mpt->m_reset_taskq, mptsas_handle_restart_ioc, (void *)mpt, DDI_SLEEP);
+		mptsas_log(mpt,CE_WARN,"mptsas_restart_ioc dispatch attempted");
+		rval = FAILED;
+/*		if (mptsas_restart_ioc(mpt)) {
 			mptsas_log(mpt, CE_WARN, "mptsas_restart_ioc failed");
 			rval = FAILED;
 		}
+*/
 	}
 
 	return (rval);
